// Datei: EEPROM.C
//
// Lesen und schreiben des Daten EEPROM im PIC
//
// Copyright 1998 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

//Daten EEPROM Adresse 'addr' lesen
unsigned char Read_EEProm(unsigned char addr)
{
  EEADR = addr;     // Adresse in Register eintragen
  RD = 1;  // Do a 'read'
  return(EEDATA);   // Wert zurckgeben
}

//Schreibt ein Byte ins EEPROM
void Write_EEProm(unsigned char addr, unsigned char data)
{
  WREN = 1;  // Schreiben ermglichen

  EEDATA = data;    // Data in data register
  EEADR = addr;     // Write to addres

  RP0 = 1;   // Set page 1 to access EECON1, EECON2
  GIE=0;     // Disable interrupts

  MOVLW(0x55);        // Writing 0x55 must be followed
  MOVWF(EECON2);         // immediately by writing 0xAA
  MOVLW(0xAA);       // to EECON2
  MOVWF(EECON2);
  BSF(WR);       // EECON1.WR=1 d.h. schreiben des EEPROM starten

  GIE = 1;   // Enable interrupts
  EEIE=1; 	//Interrupt bei EEPROM Write Complete
  RP0 = 0;   // Set page 0
//Jetzt entweder lnger warten und Verify
//oder EEPROM-Interrupt + SLEEP + Verify

  SLEEP;
}
