//Datei: PLLSER84.H
// 30MHz-PLL_Rechteckgenerator mit PIC16C84
//
// Pindefinitionen fr den PIC
//
// Holger Klabunde
// 30.04.2001
// Compiler CC5x

//Datenleitungen der LCD-Anzeige
#define D4		PORTB.0
#define D5		PORTB.1
#define D6		PORTB.2
#define D7		PORTB.3

//Ausgnge fr die Ansteuerung der LCD-Anzeige
#define LCD_RS	PORTB.4
#define LCD_CS	PORTB.5

//Leitungen um den PLL-Teiler seriell zu programmieren
#define STROBE	PORTB.6
#define DATA	D4		//Dieselbe Leitung
#define CLOCK	LCD_RS	//Dieselbe Leitung

//Solange LCD_CS nicht High ist knnen D4 und LCD_RS verndert werden
//Dasselbe gilt fr DATA und CLOCK solange STROBE Low bleibt
//DATA und D4, sowie LCD_RS und CLOCK knnen sich deshalb die Leitung
//teilen. 
//Das bedeutet aber auch, da vor dem setzen von STROBE oder LCD_CS
//die anderen Leitungen in einen definierten Zustand gebracht werden.

//Frequenzbereich der PLL umschalten
#define RELAIS	PORTB.7

//Eingnge fr die 5 Bedientaster an PORTA
//Masken zum auswerten der Tastatur
//Achtung LOW aktiv !!
#define DOWN	0x01
#define UP		0x02
#define RIGHT	0x04
#define LEFT	0x08
#define STORE	0x10
