// Datei: SETPLL.C
// 30MHz-PLL_Rechteckgenerator mit PIC16C|F84
//
// Programmiert den Teiler der PLL seriell
//
// Copyright 1998 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

//Der Takt des PIC betrgt 204.8kHz
//Ein Maschinenzyklus damit ca. 19.5us

#include "prozess.h"      /* Der verwendete Prozessor */
#include "pllser84.h"
#include "protos.h"

//Die Anzeigewerte in das Teilerschieberegister schieben
//und bernehmen
void SetPLL()
{

//Maximalwert Kontrolle fr Frequenz < 41MHz
//Der 74HCT4046 schafft scheinbar maximal 30MHz
//Hier spter display[1]>2 eintragen
//Zu Versuchszwecken ersma berdimensionieren

 if((display[1]>3)&&(display[2]>0))
  { result=1; return; } //Wert zu gro

//Die drei Bytes in den Teiler schreiben
//Die hchste Stelle zuerst
 result=(display[1]<<4)+display[2];
 WritePLLByte(result);
 result=(display[3]<<4)+display[4];
 WritePLLByte(result);
 result=(display[5]<<4)+display[6];
 WritePLLByte(result);
 STROBE=1; //Wert bernehmen
 NOP;
 STROBE=0; //und halten

 // unter 200kHz 470pF + 18pF als Kondensator fr VCO,REED-Relais on
 if((display[1]==0)&&(display[2]==0)&&(display[3]<2))
  {
   RELAIS=1;
  }
 else
 // darber nur der kleine Kondensator, Relais off
  {
   RELAIS=0;
  }

 result=0; //Kennzeichen alles OK
}

//***********************************
// Schreibt ein Byte in den Teiler
// MSB zuerst
//***********************************
void WritePLLByte(unsigned char dat)
{

 j=0x80; //Mit dem MSB anfangen
 CLOCK=0;

 for(i=0; i<8; i++)
  {
   if((dat&j)>0)
    {
     DATA=1; // 1 Bit
    }
   else
    {
     DATA=0; // 0 Bit
    }
	
   CLOCK=1; //Bit reintakten
   NOP;
   CLOCK=0;
   j=j>>1;   //Ein Bit weiter rechts
  }
}
